/*			
		Permission to use				 

  Sony Computer Entertainment supplies this lws2rsd software free 	   
  of charge to licensees along with the source code files.		 

  This lws2rsd software is experimental and no support of any kind is 	  
  available.							 

  The licensee is hereby granted permission to use, copy, modify, and	   
  distribute this lws2rsd software and documentation for any purpose. 	  
  Sony Computer Entertainment shall bear no responsibility for any 	  
  damage or loss sustained either directly or indirectly as a result of	   
  using this software. 						   

  Copyright 1997 by Sony Computer Entertainment Inc. All Rights Reserved. 

*/


typedef enum CAPValidCode {
	PARAM_T = 1,	// 001B			// bit 0: translation
	PARAM_R,		// 010B			// bit 1 : rotation
	PARAM_RT,		// 011B
	PARAM_S,		// 100B			// bit 2 : scaling
	PARAM_ST,		// 101B
	PARAM_SR,		// 110B
	PARAM_SRT,		// 111B
	PARAM_INT = 11,	//1011B			// 0x0B = 11 No S, All R & Waist T
} CAPValidCode;

typedef enum  RotationOrder {
	ROTATION_ORDER_XYZ = 0,
	ROTATION_ORDER_XZY,
	ROTATION_ORDER_YXZ,
	ROTATION_ORDER_YZX,
	ROTATION_ORDER_ZXY,
	ROTATION_ORDER_ZYX,
} RotationOrder;

typedef enum AngleUnit {
	ANGLE_RADIAN = 0,
	ANGLE_DEGREE,
} AngleUnit;

// la280 ///////////////////////////////////////////////////////////////////////
typedef enum CAPMirrorCode {
	CAP_MIRROR_TX = 1,		// 0000 0000 0001B
	CAP_MIRROR_TY = 2,		// 0000 0000 0010B
	CAP_MIRROR_TZ = 4,  	// 0000 0000 0100B
	CAP_MIRROR_RX = 16,		// 0000 0001 0000B
	CAP_MIRROR_RY = 32,		// 0000 0010 0000B
	CAP_MIRROR_RZ = 64, 	// 0000 0100 0000B
	CAP_MIRROR_SX = 256,	// 0001 0000 0000B
	CAP_MIRROR_SY = 512,	// 0010 0000 0000B
	CAP_MIRROR_SZ = 1024,  	// 0100 0000 0000B
} CAPMirrorCode;	
// la280 ///////////////////////////////////////////////////////////////////////

#ifndef CAP
extern Matrix			SetupSystemMatrix( int FLTcode );
extern int				SetFLTcode( char *lineBuffer );
extern CAPValidCode		SetValidCode( char *lineBuffer  );
extern RotationOrder	SetRotationOrder( char *lineBuffer );
extern AngleUnit		SetAngleUnit( char *lineBuffer  );
extern Matrix			SetRotationMatrix2( ParamPtr angle, RotationOrder order );
extern void				Transform( Scalar scaleLw2Ps, ParamPtr s, ParamPtr r, ParamPtr t, ParamPtr s2, ParamPtr r2, ParamPtr t2 );
#endif
