/*			
		Permission to use				 

  Sony Computer Entertainment supplies this lws2rsd software free 	   
  of charge to licensees along with the source code files.		 

  This lws2rsd software is experimental and no support of any kind is 	  
  available.							 

  The licensee is hereby granted permission to use, copy, modify, and	   
  distribute this lws2rsd software and documentation for any purpose. 	  
  Sony Computer Entertainment shall bear no responsibility for any 	  
  damage or loss sustained either directly or indirectly as a result of	   
  using this software. 						   

  Copyright 1997 by Sony Computer Entertainment Inc. All Rights Reserved. 

*/																						

#define PI		3.14159265358979323846264
#define PI2		6.28318530717958647692528
#define RAD		0.01745329251994
#define DEG		57.29577951308

#define ABS(x)		(((x)<0) ? -(x) : (x))
#define FLOOR(x)	(((x)>0) ? (Int)(x) : -((Int)(-(x))))
#define CEILING(x)	(((x) == ((Int)(x))) ? (x) : (((x)>0) ? ((Int)(x)+1) : -((Int)(-(x))+1)))
#define ROUND(x)	(((x)>0) ? (Int)((x)+0.5) : -((Int)((-(x))+0.5)))
#define MIN(a,b)	(((a)<(b)) ? (a) : (b))	 
#define MAX(a,b)	(((a)>(b)) ? (a) :(b) )	 
#define SWAP(a,b)			{ (a)^=(b); (b)^=(a); (a)^=(b); }
#define CLAMP(x,MIN,MAX)	((x)<(MIN)?(MIN):(x)>(MAX)?(MAX):(x))

#define Scalar	float

typedef struct Vector3 {
	Scalar			x;
	Scalar			y;
	Scalar			z;
} Vector3, *Vector3Ptr;

#define Param		Vector3
#define ParamPtr	Vector3Ptr

typedef struct Vector {
	Scalar			x;
	Scalar			y;
	Scalar			z;
	Scalar			w;
} Vector, *VectorPtr;


typedef struct Matrix {
	Scalar			M[4][4];
} Matrix, *MatrixPtr;


#ifndef VEC_MAT
extern Vector3  MatrixVector43( MatrixPtr m, Vector3Ptr v );
extern Vector	MatrixVector( MatrixPtr m, VectorPtr v );
extern Matrix	TransposeMatrix( MatrixPtr A );
extern Scalar	DeterminantMatrix( MatrixPtr A );
extern int		InverseMatrix( MatrixPtr A, MatrixPtr IA );
extern Matrix	MatrixMult( MatrixPtr B, MatrixPtr A );
extern Matrix	SetScalingMatrix( ParamPtr s );
extern Matrix	SetTranslationMatrix( ParamPtr t );
extern Param	DEGtoRAD( ParamPtr angle );
extern Param	RADtoDEG( ParamPtr theta );
extern Matrix	SetXRotationMatrix( Scalar rx );
extern Matrix	SetYRotationMatrix( Scalar ry );
extern Matrix	SetZRotationMatrix( Scalar rz );
extern Matrix	SetZYXRotationMatrix( ParamPtr r );
extern Matrix	SetupMatrix( ParamPtr s, ParamPtr r, ParamPtr t );
extern Param	DecomposeScalingMatrix( MatrixPtr S );
extern Param	DecomposeTranslationMatrix( MatrixPtr T );
extern Param	DecomposeRotationMatrixZYX( MatrixPtr Rot );	
extern int		DecomposeTRStoT_R_S( MatrixPtr TRS,	MatrixPtr T, MatrixPtr R, MatrixPtr S );
extern int		DecomposeTRS2t_r_s( MatrixPtr TRS, ParamPtr t, ParamPtr r, ParamPtr s );
extern int		ComposeTRSfromT_R_S( MatrixPtr TRS, MatrixPtr T, MatrixPtr R, MatrixPtr S );
extern Matrix	SetInverseTranslationMatrix( ParamPtr t );
extern Matrix	SetInverseRotationMatrix( ParamPtr r );
extern Matrix	SetInverseScalingMatrix( ParamPtr s );
extern int		Global2LocalScalingMatrix( MatrixPtr backup_gT, MatrixPtr backup_gR, MatrixPtr gS, MatrixPtr lS );
extern int		Global2LocalRotationMatrix( MatrixPtr backup_gS, MatrixPtr gR, MatrixPtr backup_gT, MatrixPtr lR );
extern int		Global2LocalTranslationMatrix( MatrixPtr backup_gS, MatrixPtr backup_gR, MatrixPtr gT, MatrixPtr lT );
extern int		Viewing2LocalRotationMatrix( MatrixPtr backup_gT, MatrixPtr gR, MatrixPtr backup_gS, MatrixPtr lR );
extern int		Viewing2LocalTranslationMatrix( MatrixPtr gT, MatrixPtr backup_gR, MatrixPtr backup_gS, MatrixPtr lT );
extern void		SetPSXMatrix( ParamPtr s, ParamPtr r, ParamPtr t, MatrixPtr TRS );
#endif // VEC_MAT