/*--------------------------------------------------------
 	Balls for Windows: libgpu sample program
	1994-1996 (C) Sony Computer Entertainment Inc.

	̃vOMicrosoft Visual C++ 1.51 ŃRpCł܂B
	Large model ܂ Huge modelŃRpCAlibgpu.lib
	libetc.libNĂB
  --------------------------------------------------------*/
/*
#if  !(defined(M_I86CM)||defined(M_I86LM)||defined(M_I86LH))
#error Must compile as Large Model.
#endif
*/

#include <windows.h>

#undef LoadImage

#include <libgte.h>	/* libgpu.hincludeĂ */
#include <libgpu.h>
#include <libetc.h>	/* PAD ֘A */

#include <stdlib.h>	/* calloc(), rand() ̂߂ɕKv */

#define OTSIZE		1		/* size of ordering table: I[_Oe[u̐ */
#define MAXOBJ		6000	/* max sprites: XvCg({[)̏ */

/*					
 * Primitive Buffer: v~eBu֘Ãobt@
 */
typedef struct {
	DRAWENV		draw;		/* drawing environment : ` */
	DISPENV		disp;		/* display environment : \ */
	OT		ot[OTSIZE];	/* ordering table: I[_Oe[u */
	SPRT_16		*sprt;		/* 16x16 fixed-size sprite: 16x16ŒTCỸXvCg */
} DB;

/*
 * Position Buffer: XvCg̓Ɋւobt@
 */
typedef struct {
	u_short x, y;			/* current point: ݂̈ʒu */
	u_short dx, dy;			/* verocity: x */
} POS;

/*
 * \̈
 */
#define	FRAME_X		320		/* frame size:\̈TCY(320x240) */
#define	FRAME_Y		240
#define WALL_X		(FRAME_X-16)	/* reflection point: XvCg̉̈TCY */
#define WALL_Y		(FRAME_Y-16)

/* preset unchanged primitve members: v~eBuobt@̏ݒ */
static void init_prim(DB *db);	
/* parse controler: Rg[̉ */
static int  pad_read(int n);	
/* intitialze position table : {[̃X^[gʒuƈړ̐ݒ */
static int  init_point(POS *pos);
/* Window procedure: eLXg̕\ƃL[bZ[W̏ */
LRESULT CALLBACK WinProc (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam);


//#if (MAXOBJ > 3275)	/* 64kzz񂪕KvȏꍇAq[WfɂĂ */
//#if defined(M_I86HM)
//#include <malloc.h>	/* _halloc()@̂߂ɕKv */
//#define calloc _halloc
//#define free _hfree
//#else
//#error Must compile as Huge Model.
//#endif /* M_I86HM */
//#endif /* MAXOBJ */

int WINAPI WinMain (HINSTANCE hInstance, HINSTANCE hPrevInstance,
                    LPSTR lpszCmdParam, int nShowCmd)
{
	static char szAppName[] = "WinBalls";
	HWND        hwnd ;
	MSG         msg ;
	WNDCLASS    wndclass ;

	/* {[̍Wlƈړi[obt@ */
	POS	*pos;	
	/* double buffer: _uobt@̂߂Qpӂ */
	DB	db[2];	
	/* current double buffer  : _uobt@݂̂̃obt@ */
	DB	*cdb;
	/* number of balls */
	int	nobj = 1;
	/* current OT */
	OT	*ot;

	SPRT_16	*sp;
	POS	*pp;
	int	i, cnt = 0, x, y;

	if (!hPrevInstance) {
		wndclass.style         = CS_HREDRAW | CS_VREDRAW ;
		wndclass.lpfnWndProc   = WinProc; /* eLXg\уL[̃EBhEvVW */
		wndclass.cbClsExtra    = 0 ;
		wndclass.cbWndExtra    = 0 ;
		wndclass.hInstance     = hInstance ;
		wndclass.hIcon         = LoadIcon (NULL, IDI_APPLICATION) ;
		wndclass.hCursor       = LoadCursor (NULL, IDC_ARROW) ;
		wndclass.hbrBackground = GetStockObject (WHITE_BRUSH) ;
		wndclass.lpszMenuName  = NULL ;
		wndclass.lpszClassName = szAppName ;
		RegisterClass(&wndclass);
	}

	hwnd = CreateWindow (szAppName,	/* window class name	*/
		"libgpu sample program",/* window caption	*/
		WS_OVERLAPPEDWINDOW,	/* window style		*/
		CW_USEDEFAULT,		/* initial x position	*/
		CW_USEDEFAULT,		/* initial y position	*/
		CW_USEDEFAULT,		/* initial x size	*/
		CW_USEDEFAULT,		/* initial y size	*/
		NULL,			/* parent window handle */
		NULL,			/* window menu handle	*/
		hInstance,		/* instance handle	*/
		NULL);			/* creation parameters	*/

	ShowWindow (hwnd, nShowCmd) ;
	UpdateWindow (hwnd) ;

	/* aboard.iniǂŃA[eBXg{[h̃|[gAhX擾 */
	if ((i = GetPortId()) == 0) {
		MessageBox(NULL, "No port address.  Please set it by aboard.exe.", NULL, MB_ICONSTOP);
		return 1;
	}
	/* |[gAhXZbg */
	SetPortId(i);

	/* ̊m */
	db[0].sprt = (SPRT_16 *)calloc(MAXOBJ, sizeof(SPRT_16));
	db[1].sprt = (SPRT_16 *)calloc(MAXOBJ, sizeof(SPRT_16));
	pos = (POS *)calloc(MAXOBJ, sizeof(POS));

	if ((db[0].sprt == NULL) || (db[1].sprt == NULL) || (pos == NULL)) {
		MessageBox(NULL, "Not enough memory", NULL, MB_ICONSTOP);
		exit(1);
	}

	/* reset PAD: Rg[̃ZbgBftHg̃L[蓖Ă */
	PadInit(1);			

	/* reset graphics sysmtem (0:cold,1:warm); `E\̃Zbg */
	ResetGraph(0);		
							 
	/* inititlalize environment for double buffer
	: `E\_uobt@pɐݒ
	(0,  0)-(320,240)ɕ`悵ĂƂ(0,240)-(320,480)\(db[0])
	(0,240)-(320,480)ɕ`悵ĂƂ(0,  0)-(320,240)\(db[1])
	*/
	SetDefDrawEnv(&db[0].draw, 0,   0, 320, 240);
	SetDefDrawEnv(&db[1].draw, 0, 240, 320, 240);
	SetDefDispEnv(&db[0].disp, 0, 240, 320, 240);
	SetDefDispEnv(&db[1].disp, 0,   0, 320, 240);

	/* :{tHgp^[t[obt@Ƀ[h */
	FntLoad(960, 256);	
	
	/* :tHg̕\ʒu̐ݒ */
	SetDumpFnt(FntOpen(16, 16, 256, 200, 0, 512));

	/* initialize primitive buffer: v~eBuobt@̏ݒ(db[0])*/
	init_prim(&db[0]);	
	
	/* initialize primitive buffer: v~eBuobt@̏ݒ(db[1])*/
	init_prim(&db[1]);	
	
	/* set initial geometries: {[̓Ɋւ鏉ݒ */
	init_point(pos);	

	/* enable to display: fBXvCւ̕\Jn */
	SetDispMask(1);		/* 0:inhibit,1:enable: OFs  PF */

	/* main loop: C[v */
	for (;;) {
		while (PeekMessage (&msg, NULL, 0, 0, PM_REMOVE)) {
			if (msg.message == WM_QUIT)
				return 0;
			TranslateMessage (&msg) ;
			DispatchMessage (&msg) ;
		}
		/* Idle */
		if ((nobj = pad_read(nobj)) <= 0)
			break;

		/* swap double buffer ID: _uobt@|C^̐؂ւ */
		cdb  = (cdb==db)? db+1: db;	

 		/* clear ordering table: I[_Oe[ũNA */
		ClearOTag(cdb->ot, OTSIZE);

		/* update sprites :
		    {[̈ʒuPvZĂnsɓo^Ă */
		ot = cdb->ot;
		sp = cdb->sprt;
		pp = pos;

		for (i = 0; i < nobj; i++, sp++, pp++) {
			/* detect reflection:
			   Wl̍XVщʏł̈ʒǔvZ */
			if ((x = (pp->x += pp->dx) % WALL_X*2) >= WALL_X)
				x = WALL_X*2 - x;
			if ((y = (pp->y += pp->dy) % WALL_Y*2) >= WALL_Y)
				y = WALL_Y*2 - y;

			/* update vertex: vZWlZbg */
			setXY0(sp, x, y);	
			
			/* apend to OT: ns֓o^ */
			AddPrim(ot, sp);	
		}
		/* wait for end of drawing: `̏I҂ */
		DrawSync(0);		
		VSync(0);		/* wait for V-BLNK (1/60) */
		++cnt;

		/*: _uobt@̐ؑւ */
		/* update display environment: \̍XV */
		PutDispEnv(&cdb->disp); 
		
		/* update drawing environment: `̍XV */
		PutDrawEnv(&cdb->draw); 
		
		/*: nsɓo^ꂽv~eBu̕` */
		DrawOTag(cdb->ot);	


		/*: {[̐ƌoߎԂ̃vg */
		FntPrint(0,"sprite = %d\n", nobj);
		FntPrint(0,"total time = %d\n", cnt);

		FntFlush(-1);
	}
	
	free(db[0].sprt);
	free(db[1].sprt);	
	free(pos);
}

/*
 * Initialize drawing Primitives: v~eBuobt@̏ݒ
 */
#include "balltex.h"	/* {[̃eNX`p^[Ăt@C */
static void init_prim(DB *db)
{
	u_short	clut[32];		/* CLUT entry: eNX` CLUT */
	SPRT_16 *sp;			/* work */
	int	i;			/* work */

	/* set bg color: wiF̃Zbg */
	db->draw.isbg = 1;
	setRGB0(&db->draw, 60, 120, 120);

	/* load texture pattern: eNX`̃[h */
	db->draw.tpage = LoadTPage(ball16x16, 0, 0, 640, 0, 16, 16);

	/* load texture CLUT: eNX` CLUT̃[h */
	for (i = 0; i < 32; i++) {
		u_short c = clut[i] = LoadClut(ballcolor[i], 0, 480+i);
	}
	/* initialize sprite: XvCg̏ */
	for (sp = db->sprt, i = 0; i < MAXOBJ; i++, sp++) {
		/* set SPRT_16: 16x16XvCgv~eBȕ */
		SetSprt16(sp);		
		
		/* semi-ambient is OFF: It */
		SetSemiTrans(sp, 0);	
		
		/* shaded texture is OFF: VF[fBOsȂ */
		SetShadeTex(sp, 1);	
		
		/* texture point is (0,0): u,v(0,0)ɐݒ */
		setUV0(sp, 0, 0);	
		
		/* set CLUT: CLUT ̃Zbg */
		sp->clut = clut[i%32];	
	}
}

/*
 * Initialize sprite position and verocity:
 : {[̃X^[gʒuƈړʂݒ肷
 */
static init_point(POS *pos)	
{
	int	i;

	for (i = 0; i < MAXOBJ; i++) {
		pos->x  = rand();		/*: X^[gW w */
		pos->y  = rand();		/*: X^[gW x */
		pos->dx = (rand() % 4) + 1;	/*: ړ w (1<=x<=4) */
		pos->dy = (rand() % 4) + 1;	/*: ړ x (1<=y<=4) */
		pos++;
	}

	return 0;
}

/*
 * Read control pad: Rg[̉
 */
/* int n; XvCg̐ */
static int pad_read(int	n)		
{
	u_long padd;

	padd = PadRead(1);			/*: Rg[̓ǂݍ */

	if (padd & PADLup)	n += 4;		/*: ̏\L[Abv */
	if (padd & PADLdown)	n -= 4;		/*: ̏\L[_E */

	if (padd & PADselect) 	return(-1);	/*: vȌI */

	limitRange(n, 1, MAXOBJ-1);	/*: n1<=n<=(MAXOBJ-1)̒lɂ */
	
	return(n);
}


/* RECTwindows.hƂ̏Փ˂邽߂libgpu.hdefineĂ܂ */
#undef RECT

/* eLXg\̂߂̃EBhEvVW */
static const char instruction[] = "\'E\' to increase, \'C\' to decrease, \'G\' to end";
LRESULT CALLBACK WinProc (HWND hwnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	HDC hdc;
	PAINTSTRUCT ps;
	RECT rect;

	switch (message) {
	case WM_PAINT:
		hdc = BeginPaint(hwnd, &ps);
		EndPaint(hwnd, &ps);
		GetClientRect(hwnd, &rect);
		DrawText(hdc, instruction, -1, &rect, DT_CENTER|DT_VCENTER|DT_SINGLELINE);
		return 0;
	default:
		return PadReadProc(hwnd, message, wParam, lParam);
//		return DefWindowProc (hwnd, message, wParam, lParam);
	}
}

/* libetc.libŎĂEBhEvVWPadReadProc()B
 * QlɓƎ̃EBhEvVW쐬邱Ƃł܂B 
long FAR PASCAL _export PadReadProc (HWND hwnd, UINT message, UINT wParam, LONG lParam)
{
 	switch (message) {
 	case WM_KEYDOWN:
		if (wParam < VK_MAX) {
			KeyDown(wParam);
			return 0;
		}
		break;
	case WM_KEYUP:
		if (wParam < VK_MAX) {
			KeyUp(wParam);
			return 0;
		}
		break;
	case WM_DESTROY:
		PostQuitMessage (0) ;
		break;
	}
	return DefWindowProc (hwnd, message, wParam, lParam) ;
}
 */