/*
 *	MIMeWave data viewer
 *
 *	"wave.c"
 *
 *		Version 1.00	June 13, 1995
 *
 *		Copyright (C) 1995 by Sony Computer Entertainment Inc.
 *		All Rights Reserved.
 */

#include <stdio.h>
#include "wave.h"

int wave_init(WAVE *w, WAVE_PR *wp, unsigned long *addr, int repeatp)
{
    int i;
    unsigned long len;

    w->wp= wp;					/* Set waveform data
						/* g`f[^̈̃Zbg */
    w->num= *addr++;				/* number of waveforms
						/* g`̐ */
    w->repeat=repeatp;				/* repeat mode?
						/* repeat 邩ǂ */
    len= 0;
    for (i=0; i<w->num; i++){
	w->wp[i].size= *addr++;			/* Set length of waveform
						/* g`̒Zbg */
	if (len< w->wp[i].size) len=w->wp[i].size;
	w->wp[i].pr= addr;			/* Set start address of waveform data
						/* g`f[^̐擪AhXZbg */
	addr+=w->wp[i].size;			/* get next waveform /* ̔g` */
    }

    w->length=len;			/* Set length of the longest waveform
					/* Ƃ肠Œ̂̂ɍ킹 */

    if (len==0) return -1;		/* no waveform data /* g`f[^Ȃ */
    return w->num;			/* Return number of waveforms
					/* g`̐Ԃ */
}

long wavepr(WAVE *w, long id)
{
    long s;

    s=w->s;
#if 0
    if (s>=w->wp[id].size) s=w->wp[id].size-1;	/* Overflow /* g`zf[^ */
    return (w->wp[id].pr[s]);
#endif /* 0 */
    if (s>=w->wp[id].size) return 0;		/* Overflow /* g`zf[^ */
    else return (w->wp[id].pr[s]);
}

long waveset(WAVE *w, unsigned long s)
{
    if (w->repeat==WAVE_REPEAT) s%=w->length;	/* repeat */
    w->s=s;
}
